<template>
  <v-container>
    <v-card class="pa-4">
      <p class="app-title">Add Inventory</p>
      <ValidationObserver ref="form" v-slot="{ handleSubmit }">
        <form @submit.prevent="handleSubmit(submitForm)">
          <ValidationProvider
            v-slot="{ errors }"
            name="inventory name"
            rules="required"
          >
            <!-- jika respon ingin di pasing (return-object) -->
            <v-autocomplete
              dense
              v-model="name"
              :items="listProduct"
              item-text="inventory_name"
              item-value="inventory_name"
              :search-input.sync="search"
              :error-messages="errors"
              placeholder="Type to search....."
              outlined
            ></v-autocomplete>
          </ValidationProvider>
          <ValidationProvider
            v-slot="{ errors }"
            name="Desctiption"
            rules="required"
          >
            <v-textarea
              label="Description"
              :error-messages="errors"
              v-model="description"
              outlined
            ></v-textarea>
          </ValidationProvider>
          <ValidationProvider
            v-slot="{ errors }"
            name="Quantity"
            rules="required"
          >
            <v-text-field
              label="quantity"
              v-model="quantity"
              :error-messages="errors"
              outlined
              type="number"
              suffix="pcs"
              placeholder="100"
            >
            </v-text-field>
          </ValidationProvider>
          <div v-for="(item, index) in arrayDynamic" :key="index.id">
            <v-row>
              <v-col cols="6" lg="auto" md="auto" xs="6" class="py-1">
                Product - {{ index + 1 }}
              </v-col>
              <v-col cols="12" lg="5" md="5" xs="12" class="py-1">
                <ValidationProvider
                  v-slot="{ errors }"
                  :name="'Product Name' + [index + 1]"
                  rules="required"
                >
                  <v-text-field
                    label="Product Name"
                    v-model="productName[index]"
                    :error-messages="errors"
                    outlined
                  >
                  </v-text-field>
                </ValidationProvider>
              </v-col>
              <v-col cols="6" lg="2" md="2" xs="6" class="py-1">
                <ValidationProvider
                  v-slot="{ errors }"
                  :name="'Product Quantity' + [index + 1]"
                  rules="required"
                >
                  <v-text-field
                    label="Product Quantity"
                    v-model="productQty[index]"
                    type="number"
                    :error-messages="errors"
                    outlined
                  >
                  </v-text-field>
                </ValidationProvider>
              </v-col>
              <v-col cols="6" lg="2" md="2" xs="6" class="py-1">
                <ValidationProvider
                  v-slot="{ errors }"
                  :name="'Unit' + [index + 1]"
                  rules="required"
                >
                  <v-select
                    :items="items"
                    v-model="unit[index]"
                    item-text="text"
                    item-value="text"
                    :error-messages="errors"
                    dense
                    outlined
                  ></v-select>
                </ValidationProvider>
              </v-col>
              <v-col cols="6" lg="auto" md="auto" xs="6" class="py-1">
                <v-btn icon color="red" @click="removeConfigurationRow(index)"
                  ><v-icon>mdi-delete</v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </div>
          <div>
            <v-btn block color="#f26525" @click="addConfigurationRow()">
              <span class="text-white">Tambah Product</span>
            </v-btn>
          </div>
          <div>
            <v-btn
              outlined
              :loading="loading"
              color="primary"
              type="submit"
              class="my-5"
              >Submit</v-btn
            >
            <v-btn outlined color="red" class="ma-5" @click="goBack()"
              >Cancel</v-btn
            >
          </div>
        </form>
      </ValidationObserver>
    </v-card>
  </v-container>
</template>
<script>
import { createNamespacedHelpers } from "vuex";
const inventory = createNamespacedHelpers("inventory");
export default {
  data() {
    return {
      name: null,
      search: null,
      description: null,
      quantity: null,
      productName: [],
      productQty: [],
      unit: [],
      arrayDynamic: [null],
      tempDynamic: [],
      loading: false,
      items: [
        {
          id: 1,
          text: "Ton"
        },
        {
          id: 2,
          text: "Kwintal"
        },
        {
          id: 3,
          text: "Kg"
        },
        {
          id: 4,
          text: "Hg"
        },
        {
          id: 5,
          text: "Ons"
        },
        {
          id: 6,
          text: "Gram"
        }
      ]
    };
  },
  computed: {
    ...inventory.mapState(["listProduct"])
  },
  watch: {
    // name(newval) {
    //   this.description = newval.type;
    // },
    search(newval) {
      if (newval.length > 2) {
        this.$store.commit("inventory/SET_SEARCH", newval);
        this.$store.dispatch("inventory/getProduct");
      }
    }
  },
  methods: {
    goBack() {
      this.$router.go(-1);
    },
    addConfigurationRow() {
      this.arrayDynamic.push(null);
      this.productName.push(null);
      this.productQty.push(null);
      this.unit.push(null);
    },
    removeConfigurationRow(index) {
      this.arrayDynamic.splice(index, 1);
      this.productName.splice(index, 1);
      this.productQty.splice(index, 1);
      this.unit.splice(index, 1);
    },
    submitForm() {
      this.loading = true;
      var tempProduct = {};
      tempProduct.name_product = this.name;
      tempProduct.description = this.description;
      tempProduct.pcs = this.quantity;

      this.arrayDynamic.forEach((data, index) => {
        this.tempDynamic.push({
          inventory_name: this.productName[index],
          quantity: this.productQty[index],
          unit: this.unit[index]
        });
      });
      tempProduct.array = JSON.stringify(this.tempDynamic);
      var formData = new FormData();
      for (var key in tempProduct) {
        formData.append(key, tempProduct[key]);
      }
      this.$store.commit("inventory/SET_TEMPDATA", formData);
      this.$store
        .dispatch("inventory/insertData")
        .then(response => {
          const res = response.data;
          const messagesSuccess = res.status.message;
          if (res.status) {
            this.loading = false;
            this.$swal
              .fire("Success!!", messagesSuccess, "success")
              .then(result => {
                if (result.isConfirmed) {
                  this.$router.push("/inventory");
                  // this.$router.go(-1) backto sebelumnya

                  // this.$router.go() backto sebelumnya
                }
              });
          }
        })
        .catch(error => {
          this.loading = false;
          const messagesError = error.response.data.status.message;
          this.$swal.fire("Error!!", messagesError, "error");
        });
    }
  }
};
</script>
